extern "C"
{
#include "fxlib.h"
#include "stddef.h"
}

#include "Game.hpp"
#include "Classes.hpp"
#include "Timer.hpp"
#include "OtherFunc.hpp"

// Mthodes "Classiques"

void Unite :: Create(int styleUnite, int xUnite, int yUnite)
{
	m_Type = styleUnite;
	m_PositionX = xUnite; m_GoTo_X = m_PositionX;
	m_PositionY = yUnite; m_GoTo_Y = m_PositionY;
	m_HealthPoints = Get_HealthPointsMax();
	m_LastTime = Get_ShootTime();
	m_LastTime = 0;
	m_LastShoot = 0;
}

void Unite :: Delete()
{
	m_Type = 0;
	m_PositionX = -2; m_GoTo_X = m_PositionX;
	m_PositionY = -2; m_GoTo_Y = m_PositionY;
	m_HealthPoints =0;
	m_LastTime = 0;
	m_LastTime = 0;
	m_LastShoot = 0;
}

void Unite :: Stop(float time)
{
	m_Stop = Timer_GetTime() + time;
}

void Unite :: TestAction()
{
	if (m_Stop < Timer_GetTime()) {
		Move();
		if(m_LastShoot != 0) Attack_Act();
	}
}

void Unite :: Attack(Unite* uniteAttaquee)
{
	m_LastShoot = uniteAttaquee;
}

void Unite :: Attack_Act()
{
	int a;
	if((m_LastShoot != 0) && (m_LastTime + Get_ShootTime() <= Timer_GetTime())) {
		if(m_LastShoot->Get_Type() == 0) {
			m_LastShoot = 0;
			return;
		}
		if(Test_Range(m_PositionX, m_PositionY, Get_Range(), m_LastShoot->Get_PositionX(), m_LastShoot->Get_PositionY())) {
			m_LastShoot->LooseHP(Get_Attack(), Get_AA_Attack());
			m_LastTime = Timer_GetTime();
		}
		else {
			a = 0;
			if (m_PositionX > m_LastShoot->Get_PositionX()) a = 1;
			if (m_PositionX < m_LastShoot->Get_PositionX()) a = 2;
			if (m_PositionY > m_LastShoot->Get_PositionY()) a = 3;
			if (m_PositionY < m_LastShoot->Get_PositionY()) a = 4;
			switch (a) {
				case 1 : m_GoTo_X = m_PositionX - 1; break;
				case 2 : m_GoTo_X = m_PositionX + 1; break;
				case 3 : m_GoTo_Y = m_PositionY - 1; break;
				case 4 : m_GoTo_Y = m_PositionY + 1; break;
				default : break;
			}
		}
	}
	if(m_LastShoot->Get_Type() == 0) m_LastShoot = 0;
}

void Unite :: LooseHP(int hPLoosed, int hPLoosedAA)
{
	if((m_Type == 7) || (m_Type == 8) || (m_Type == 9)) hPLoosed = hPLoosedAA;
	m_HealthPoints -= hPLoosed;
	if(m_HealthPoints <= 0) Delete();
}

void Unite :: GoTo(int x, int y)
{
	m_GoTo_X = x;
	m_GoTo_Y = y;
	m_LastShoot = 0;
}

void Unite :: Move()
{
	int a = 0;
	if ((m_LastTime + Get_MoveTime() > Timer_GetTime()) || (Get_MoveTime() == 0.0)) return;

	if (!((m_GoTo_X == m_PositionX) && (m_GoTo_Y == m_PositionY))) {

		if ((m_PositionX >= m_GoTo_X) && (m_PositionY >= m_GoTo_Y)) {
			if((m_PositionX - m_GoTo_X > m_PositionY - m_GoTo_Y) && (Test_XY(m_PositionX-1, m_PositionY) == 0)) a = 1;
			else {
				if(Test_XY(m_PositionX, m_PositionY-1) == 0) a = 3;
				else if(Test_XY(m_PositionX-1, m_PositionY) == 0) a = 1;
			}
			if((m_PositionX == m_GoTo_X) && (m_PositionY == m_GoTo_Y)) a = 0;
		}

		if ((m_PositionX <= m_GoTo_X) && (m_PositionY >= m_GoTo_Y)) {
			if((m_GoTo_X - m_PositionX > m_PositionY - m_GoTo_Y) && (Test_XY(m_PositionX+1, m_PositionY) == 0)) a = 2;
			else {
				if(Test_XY(m_PositionX, m_PositionY-1) == 0) a = 3;
				else if(Test_XY(m_PositionX+1, m_PositionY) == 0) a = 2;
			}
			if((m_PositionX == m_GoTo_X) && (m_PositionY == m_GoTo_Y)) a = 0;
		}

		if ((m_PositionX >= m_GoTo_X) && (m_PositionY <= m_GoTo_Y)) {
			if((m_PositionX - m_GoTo_X > m_GoTo_Y - m_PositionY) && (Test_XY(m_PositionX-1, m_PositionY) == 0)) a = 1;
			else {
				if(Test_XY(m_PositionX, m_PositionY+1) == 0) a = 4;
				else if(Test_XY(m_PositionX-1, m_PositionY) == 0) a = 1;
			}
			if((m_PositionX == m_GoTo_X) && (m_PositionY == m_GoTo_Y)) a = 0;
		}

		if ((m_PositionX <= m_GoTo_X) && (m_PositionY <= m_GoTo_Y)) {
			if((m_GoTo_X - m_PositionX > m_GoTo_Y - m_PositionY) && (Test_XY(m_PositionX+1, m_PositionY) == 0)) a = 2;
			else {
				if(Test_XY(m_PositionX, m_PositionY+1) == 0) a = 4;
				else if(Test_XY(m_PositionX+1, m_PositionY) == 0) a = 2;
			}
			if((m_PositionX == m_GoTo_X) && (m_PositionY == m_GoTo_Y)) a = 0;
		}

		switch (a) {
			case 1 : m_PositionX--; m_LastTime = Timer_GetTime(); break;
			case 2 : m_PositionX++; m_LastTime = Timer_GetTime(); break;
			case 3 : m_PositionY--; m_LastTime = Timer_GetTime(); break;
			case 4 : m_PositionY++; m_LastTime = Timer_GetTime(); break;
			default : m_GoTo_X = m_PositionX; m_GoTo_Y = m_PositionY; break;
		}
	}
}

void Unite :: RepairHP(int hPGets)
{
	m_HealthPoints = m_HealthPoints + hPGets;
	if (m_HealthPoints > Get_HealthPointsMax()) m_HealthPoints = Get_HealthPointsMax();
}

void Unite :: SpecialCapacity()
{
	if(m_Stop < Timer_GetTime()) {
		Unite *v;
		switch(m_Type)
		{
			case 3 :
				v = Select_UniteEnnemie();
				if (v != 0) {
					if((v->Get_Type() < 10) || !((v->Get_PositionX() == m_PositionX+1) || (v->Get_PositionY() == m_PositionY+1) || (v->Get_PositionX() == m_PositionX-1) || (v->Get_PositionY() == m_PositionY-1))) break;
					Create(v->Get_Type(), v->Get_PositionX(), v->Get_PositionY());
					v->Delete();
					break;
				}
				v = Select_UniteAlliee();
				if (v != 0) {
					if((v->Get_Type() < 10) || !((v->Get_PositionX() == m_PositionX+1) || (v->Get_PositionY() == m_PositionY+1) || (v->Get_PositionX() == m_PositionX-1) || (v->Get_PositionY() == m_PositionY-1))) break;
					Create(v->Get_Type(), v->Get_PositionX(), v->Get_PositionY());
					v->Delete();
					break;
				}
				break;
			case 4 :
				if(!Depense(Get_Prize(12))) break;
				Create(12, m_PositionX, m_PositionY);
				Stop(30);
				break;
			case 12 :
				if(!Depense(Get_Prize(20))) break;
				Create(20, m_PositionX, m_PositionY);
				Stop(90);
				break;
			case 50 :
				if(Get_CargoNumber() >= Get_CargoMax()) break;
				v = Select_UniteAlliee();
				if(v->Get_Type() > 9) break;
				v->Out_Position();
				mTab_Cargo[Get_CargoNumber()+1] = v;
				break;
			default : break;
		}
	}
}

bool Unite :: Cargo_In(Unite* uniteGet)
{
	if(!Get_IsStop()) return false;
	if(uniteGet == 0) return false;
	if((uniteGet->Get_Type() < 4) && (Get_CargoNumber() < Get_CargoMax()) && Test_Range(m_PositionX, m_PositionY, 1, uniteGet->Get_PositionX(), uniteGet->Get_PositionY())) {
		mTab_Cargo[Get_CargoNumber()] = uniteGet;
		uniteGet->Out_Position();
		Unselect();
		return true;
	}
	else {
		return false;
	}
}

void Unite :: Cargo_Out(int uniteGet, int x, int y)
{
	if(mTab_Cargo[uniteGet] != 0) {
		mTab_Cargo[uniteGet]->In_Position(x, y);
		mTab_Cargo[uniteGet] = 0;
	}
}

void Unite :: Out_Position()
{
	m_PositionX = -1; m_GoTo_X = -1;
	m_PositionY = -1; m_GoTo_Y = -1;
}

void Unite :: In_Position( int xPos, int yPos)
{
	if ((m_PositionX == -1) && (m_PositionY == -1)) {
		m_PositionX = xPos; m_GoTo_X = xPos;
		m_PositionY = yPos; m_GoTo_Y = yPos;
	}
}

// __________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

// Mthodes "Get"

char Unite :: Get_Type()
{
	return m_Type;
}

int Unite :: Get_HealthPoints()
{
	return m_HealthPoints;
}

int Unite :: Get_PositionX()
{
	return m_PositionX;
}

int Unite :: Get_PositionY()
{
	return m_PositionY;
}

float Unite :: Get_LastTime()
{
	return m_LastTime;
}

//					*-----------*

int Unite :: Get_HealthPointsMax()
{
	int a;
	switch (m_Type)
	{
		case 1 : a = 100; break;
		case 2 : a = 250; break;
		case 3 : a = 100; break;
		case 4 : a = 1000; break;
		case 5 : a = 1500; break;
		case 6 : a = 1500; break;
		case 7 : a = 1000; break;
		case 8 : a = 1000; break;
		case 9 : a = 1000; break;
		case 10 : a = 5000; break;
		case 11 : a = 5000; break;
		case 12 : a = 5000; break;
		case 13 : a = 2500; break;
		case 14 : a = 2500; break;
		case 15 : a = 3000; break;
		case 16 : a = 3000; break;
		case 20 : a = 10000; break;
		case 25 : a = 5000; break;
		case 30 : a = 7500; break;
		case 35 : a = 7500; break;
		case 40 : a = 5000; break;
		case 45 : a = 7500; break;
		case 50 : a = 10000; break;
		default : a = 0; break;
	}
	return a;
}

int Unite :: Get_Attack()
{
	int a;
	switch (m_Type)
	{
		case 1 : a = 100; break;
		case 2 : a = 50; break;
		case 3 : a = 50; break;
		case 4 : a = 0; break;
		case 5 : a = 150; break;
		case 6 : a = 250; break;
		case 7 : a = 150; break;
		case 8 : a = 0; break;
		case 9 : a = 500; break;
		case 10 : a = 0; break;
		case 11 : a = 0; break;
		case 12 : a = 0; break;
		case 13 : a = 150; break;
		case 14 : a = 0; break;
		case 15 : a = 250; break;
		case 16 : a = 500; break;
		case 20 : a = 0; break;
		case 25 : a = 0; break;
		case 30 : a = 0; break;
		case 35 : a = 0; break;
		case 40 : a = 1500; break;
		case 45 : a = 5000; break;
		case 50 : a = 0; break;
		default : a = 0; break;
	}
	return a;
}

int Unite :: Get_AA_Attack()
{
	int a;
	switch (m_Type)
	{
		case 1 : a = 0; break;
		case 2 : a = 100; break;
		case 3 : a = 0; break;
		case 4 : a = 0; break;
		case 5 : a = 0; break;
		case 6 : a = 250; break;
		case 7 : a = 0; break;
		case 8 : a = 150; break;
		case 9 : a = 0; break;
		case 10 : a = 0; break;
		case 11 : a = 0; break;
		case 12 : a = 0; break;
		case 13 : a = 0; break;
		case 14 : a = 150; break;
		case 15 : a = 250; break;
		case 16 : a = 500; break;
		case 20 : a = 0; break;
		case 25 : a = 0; break;
		case 30 : a = 0; break;
		case 35 : a = 0; break;
		case 40 : a = 1500; break;
		case 45 : a = 0; break;
		case 50 : a = 0; break;
		default : a = 0; break;
	}
	return a;
}

int Unite :: Get_Range()
{
	int a;
	switch (m_Type)
	{
		case 1 : a = 3; break;
		case 2 : a = 5; break;
		case 3 : a = 2; break;
		case 4 : a = 0; break;
		case 5 : a = 5; break;
		case 6 : a = 6; break;
		case 7 : a = 4; break;
		case 8 : a = 4; break;
		case 9 : a = 1; break;
		case 10 : a = 0; break;
		case 11 : a = 5; break;
		case 12 : a = 5; break;
		case 13 : a = 5; break;
		case 14 : a = 5; break;
		case 15 : a = 6; break;
		case 16 : a = 7; break;
		case 20 : a = 10; break;
		case 25 : a = 2; break;
		case 30 : a = 2; break;
		case 35 : a = 2; break;
		case 40 : a = 10; break;
		case 45 : a = 250; break;
		case 50 : a = 0; break;
		default : a = 0; break;
	}
	return a;
}

int Unite :: Get_ShockWave()
{
	int a;
	switch (m_Type)
	{
		case 1 : a = 1; break;
		case 2 : a = 1; break;
		case 3 : a = 1; break;
		case 4 : a =0; break;
		case 5 : a = 1; break;
		case 6 : a = 1; break;
		case 7 : a = 1; break;
		case 8 : a = 1; break;
		case 9 : a = 2; break;
		case 10 : a = 0; break;
		case 11 : a = 0; break;
		case 12 : a = 0; break;
		case 13 : a = 1; break;
		case 14 : a = 1; break;
		case 15 : a = 1; break;
		case 16 : a = 1; break;
		case 20 : a = 0; break;
		case 25 : a = 0; break;
		case 30 : a = 0; break;
		case 35 : a = 0; break;
		case 40 : a = 3; break;
		case 45 : a = 5; break;
		case 50 : a = 0; break;
		default : a = 0; break;
	}
	return a;
}

float Unite :: Get_ShootTime()
{
	float a;
	switch (m_Type)
	{
		case 1 : a = 1; break;
		case 2 : a = 3; break;
		case 3 : a = 2; break;
		case 4 : a = 0; break;
		case 5 : a = 2; break;
		case 6 : a = 3; break;
		case 7 : a = 1; break;
		case 8 : a = 0.5; break;
		case 9 : a = 1; break;
		case 10 : a = 0; break;
		case 11 : a = 0; break;
		case 12 : a = 0; break;
		case 13 : a = 0.5; break;
		case 14 : a = 0.5; break;
		case 15 : a = 1; break;
		case 16 : a = 1; break;
		case 20 : a = 0; break;
		case 25 : a = 0; break;
		case 30 : a = 0; break;
		case 35 : a = 0; break;
		case 40 : a = 1; break;
		case 45 : a = 180; break;
		case 50 : a = 0; break;
		default : a = 0; break;
	}
	return 2*a;
}

int Unite :: Get_Visibility()
{
	int a;
	switch (m_Type)
	{
		case 1 : a = 5; break;
		case 2 : a = 5; break;
		case 3 : a = 5; break;
		case 4 : a = 5; break;
		case 5 : a = 6; break;
		case 6 : a = 6; break;
		case 7 : a = 5; break;
		case 8 : a = 5; break;
		case 9 : a = 5; break;
		case 10 : a = 6; break;
		case 11 : a = 6; break;
		case 12 : a = 6; break;
		case 13 : a = 6; break;
		case 14 : a = 6; break;
		case 15 : a = 6; break;
		case 16 : a = 7; break;
		case 20 : a = 11; break;
		case 25 : a = 6; break;
		case 30 : a = 6; break;
		case 35 : a = 6; break;
		case 40 : a = 11; break;
		case 45 : a = 6; break;
		case 50 : a = 5; break;
		default : a = 0; break;
	}
	return a;
}

int Unite :: Get_CargoMax()
{
	int a;
	switch (m_Type)
	{
		case 1 : a = 0; break;
		case 2 : a = 0; break;
		case 3 : a = 0; break;
		case 4 : a = 5; break;
		case 5 : a = 0; break;
		case 6 : a = 0; break;
		case 7 : a = 3; break;
		case 8 : a = 0; break;
		case 9 : a = 0; break;
		case 10 : a = 2; break;
		case 11 : a = 0; break;
		case 12 : a = 5; break;
		case 13 : a = 0; break;
		case 14 : a = 0; break;
		case 15 : a = 0; break;
		case 16 : a = 0; break;
		case 20 : a = 5; break;
		case 25 : a = 0; break;
		case 30 : a = 0; break;
		case 35 : a = 0; break;
		case 40 : a = 5; break;
		case 45 : a = 0; break;
		case 50 : a = 5; break;
		default : a = 0; break;
	}
	return a;
}

int Unite :: Get_CargoNumber()
{
	int a = 0;
	int i = 0;
	while(i < (Get_CargoMax())) {
		if(mTab_Cargo[i] != 0) a++;
		i++;
	}
	return a;
}

float Unite :: Get_MoveTime()
{
	float a;
	switch (m_Type)
	{
		case 1 : a = 1; break;
		case 2 : a = 1; break;
		case 3 : a = 1; break;
		case 4 : a = 1; break;
		case 5 : a = 1.5; break;
		case 6 : a = 1.5; break;
		case 7 : a = 0.5; break;
		case 8 : a = 0.5; break;
		case 9 : a = 0.5; break;
		case 10 : a = 0; break;
		case 11 : a = 0; break;
		case 12 : a = 0; break;
		case 13 : a = 0; break;
		case 14 : a = 0; break;
		case 15 : a = 0; break;
		case 16 : a = 0; break;
		case 20 : a = 0; break;
		case 25 : a = 0; break;
		case 30 : a = 0; break;
		case 35 : a = 0; break;
		case 40 : a = 0; break;
		case 45 : a = 0; break;
		case 50 : a = 0; break;
		default : a = 0; break;
	}
	return 2*a;
}

Unite* Unite :: Get_CargoUnit(int X)
{
	return mTab_Cargo[X];
}

int Unite :: Get_Sprite(int x, int y)
{
	if ((m_PositionX+1 == x) && (m_PositionY == y) && (m_Type == 40)) return 41;
	if ((m_PositionX+1 == x) && (m_PositionY+1 == y) && (m_Type == 40)) return 43;
	if(m_Type == 40) return 0;
	if ((m_PositionX == x) && (m_PositionY == y) && (m_Type < 17)) return m_Type;
	if ((m_PositionX == x) && (m_PositionY == y) && (m_Type > 19)) return (m_Type + 1);
	if ((m_PositionX+1 == x) && (m_PositionY == y) && (m_Type > 19)) return (m_Type + 2);
	if ((m_PositionX == x) && (m_PositionY+1 == y) && (m_Type > 19)) return (m_Type + 3);
	if ((m_PositionX+1 == x) && (m_PositionY+1 == y) && (m_Type > 19)) return (m_Type + 4);
	return 0;
}

bool Unite :: Get_IsStop()
{
	if(m_Stop < Timer_GetTime()) return true;
	return false;
}

bool Unite :: Get_Move()
{
	if((m_PositionX == m_GoTo_X) && (m_PositionY == m_GoTo_Y)) return true;
	return false;
}

bool Unite :: Get_IsAttacking()
{
	if(m_LastShoot == 0) return false;
	if(m_LastShoot->Get_Type() == 0) return false;
	return true;
}



// __________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________
// __________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________
// __________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

void WorldShip :: Create(char type, int x, int y)
{
	m_Type = type;
	m_Ax = x; m_Ay = y;
}

void WorldShip :: Delete()
{
	m_Type = 0;
	m_Ax = -1; m_Ay = -1;
}

int WorldShip :: Get_Sprite(int x, int y)
{
	if((m_Ax == x) && (m_Ay == y)) return m_Type;
	return 0;
}