extern "C"
{
#include "fxlib.h"
}

#include "Graphics.hpp"
#include "Game.hpp"

void Bdisp_Title()
{
	Bdisp_DrawLineVRAM(10,1,15,1);
	Bdisp_DrawLineVRAM(9,2,9,8);
	Bdisp_DrawLineVRAM(10,9,15,9);
	Bdisp_DrawLineVRAM(11,3,11,7);
	Bdisp_DrawLineVRAM(12,3,13,3);
	Bdisp_DrawLineVRAM(12,7,13,7);
	Bdisp_SetPoint_VRAM(12,5,1);
	Bdisp_DrawLineVRAM(15,6,16,7);
	Bdisp_SetPoint_VRAM(16,5,1);
	Bdisp_DrawLineVRAM(17,5,17,7);
	Bdisp_DrawLineVRAM(19,5,20,5);
	Bdisp_DrawLineVRAM(19,6,19,7);
	Bdisp_DrawLineVRAM(22,4,22,7);
	Bdisp_SetPoint_VRAM(23,5,1);
	Bdisp_DrawLineVRAM(25,4,25,7);
	Bdisp_SetPoint_VRAM(26,5,1);
	Bdisp_DrawLineVRAM(27,6,27,7);
}

void Bdisp_MenuPart(int line, int column, unsigned char* c)
{
	line--;
	PrintMini(line+3, column+3, c, MINI_OVER);
	Bdisp_DrawLineVRAM(line+1,  column+1, line+22, column+1);
	Bdisp_DrawLineVRAM(line+1,  column+9, line+22, column+9);
	Bdisp_DrawLineVRAM(line+1,  column+1, line+1, column+9);
	Bdisp_DrawLineVRAM(line+22,  column+1, line+22, column+9);
	Bdisp_PutDisp_DD();
}

void Bdisp_MenuBar(bool Can)
{
	Bdisp_DrawLineVRAM(1,56,127,56);
	PrintMini(0*21+3, 58, (unsigned char*) "Sel", MINI_OVER);
	Bdisp_DrawLineVRAM(22, 57, 22, 63);
	PrintMini(1*21+3, 58, (unsigned char*) "M/S", MINI_OVER);
	Bdisp_DrawLineVRAM(43, 57, 43, 63);
	PrintMini(2*21+3, 58, (unsigned char*) "Othr", MINI_OVER);
	Bdisp_DrawLineVRAM(64, 57, 64, 63);
	PrintMini(3*21+3, 58, (unsigned char*) "Info", MINI_OVER);
	Bdisp_DrawLineVRAM(85, 57, 85, 63);
	PrintMini(4*21+3, 58, (unsigned char*) "MMap", MINI_OVER);
	Bdisp_DrawLineVRAM(106, 57, 106, 63);
	PrintMini(5*21+3, 58, (unsigned char*) "Maj", MINI_OVER);
	Bdisp_DrawLineVRAM(122, 57, 122, 63);
	if(Can) PrintMini(124, 58, (unsigned char*) "V", MINI_OVER);
	else PrintMini(124, 58, (unsigned char*) "X", MINI_OVER);
	Bdisp_DrawLineVRAM(112,0,112,56);
}

void Bdisp_Cursor(int x, int y)
{
    Bdisp_DrawLineVRAM(x,y,x,y+1);
    Bdisp_SetPoint_VRAM(x+1,y,1);
    Bdisp_SetPoint_VRAM(x+1,y+1,0);
    Bdisp_SetPoint_VRAM(x+1,y+2,1);
    Bdisp_DrawLineVRAM(x+2,y+1,x+2,y+2);
    Bdisp_SetPoint_VRAM(x+3,y+3,1);
}

void Bdisp_HealthBar(int x, int y, int life)
{
Bdisp_DrawLineVRAM(x+1, y, x+10, y);
Bdisp_DrawLineVRAM(x, y+1, x+(life/10), y+1);
Bdisp_SetPoint_VRAM(x+11, y+1, 1);
Bdisp_DrawLineVRAM(x+1, y+2, x+10, y+2);
}


// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________


void Bdisp_Soldat(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+2,8*y+7,8*x+3,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+1,8*x+3,8*y+5);
	Bdisp_DrawLineVRAM(8*x+4,8*y+1,8*x+4,8*y+2);
	Bdisp_DrawLineVRAM(8*x+4,8*y+6,8*x+4,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+4,8*y+4,1);
}

void Bdisp_Trooper(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+2,8*y+7,8*x+3,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+1,8*x+3,8*y+5);
	Bdisp_DrawLineVRAM(8*x+4,8*y+1,8*x+4,8*y+2);
	Bdisp_DrawLineVRAM(8*x+4,8*y+6,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+4,8*x+6, 8*y+4);
}

void Bdisp_AgentSpe(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+4,8*y+3);
	Bdisp_DrawLineVRAM(8*x+3,8*y+4,8*x+5,8*y+4);
	Bdisp_DrawLineVRAM(8*x+3,8*y+6,8*x+3,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+1,8*x+5,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+6,8*x+5,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+4,8*y+5,1);
}


void Bdisp_Transporteur(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+2,8*x+5,8*y+2);
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x,8*y+4);
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x+7,8*y+5);
	Bdisp_DrawLineVRAM(8*x,8*y+6,8*x+7,8*y+6);
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+1,8*y+7,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+3,8*x+5,8*y+3);
	Bdisp_DrawLineVRAM(8*x+4,8*y+4,8*x+7,8*y+4);
	Bdisp_DrawLineVRAM(8*x+5,8*y+7,8*x+6,8*y+7);
}

void Bdisp_Char(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x+7,8*y+5);
	Bdisp_DrawLineVRAM(8*x,8*y+6,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+3,8*x+7,8*y+3);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+5,8*y+4);
	Bdisp_DrawLineVRAM(8*x+2,8*y+7,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+4,8*y+2);
	Bdisp_DrawLineVRAM(8*x+6,8*y+7,8*x+7,8*y+6);
}

void Bdisp_CharRot(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x+7,8*y+5);
	Bdisp_DrawLineVRAM(8*x,8*y+6,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+3,8*x+5,8*y+3);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+5,8*y+4);
	Bdisp_DrawLineVRAM(8*x+2,8*y+7,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+6,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+1,8*x+6,8*y+1);
	Bdisp_DrawLineVRAM(8*x+6,8*y+7,8*x+7,8*y+6);
}


void Bdisp_Helicoptere(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x+1,8*y+3);
	Bdisp_DrawLineVRAM(8*x,8*y+4,8*x+2,8*y+4);
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+7,8*y+1);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+3,8*y+5);
	Bdisp_DrawLineVRAM(8*x+3,8*y+7,8*x+7,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+4,8*y+6);
	Bdisp_DrawLineVRAM(8*x+5,8*y+2,8*x+5,8*y+5);
	Bdisp_DrawLineVRAM(8*x+6,8*y+5,8*x+6,8*y+6);
	Bdisp_DrawLineVRAM(8*x+7,8*y+3,8*x+7,8*y+5);
	Bdisp_SetPoint_VRAM(8*x+6,8*y+2,1);
}

void Bdisp_Chasseur(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+1,8*y+4,8*x+6,8*y+4);
	Bdisp_DrawLineVRAM(8*x+2,8*y+3,8*x+5,8*y+3);
	Bdisp_DrawLineVRAM(8*x+2,8*y+5,8*x+6,8*y+5);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+5,8*y+2);
	Bdisp_DrawLineVRAM(8*x+4,8*y+6,8*x+5,8*y+6);
	Bdisp_DrawLineVRAM(8*x+6,8*y+7,8*x+7,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+4,8*y+1,1);
	Bdisp_SetPoint_VRAM(8*x+7,8*y+6,1);
}

void Bdisp_Bombardier(int x, int y)
{

	Bdisp_DrawLineVRAM(8*x+1,8*y+3,8*x+4,8*y+3);
	Bdisp_DrawLineVRAM(8*x+2,8*y+2,8*x+3,8*y+2);
	Bdisp_DrawLineVRAM(8*x+3,8*y+4,8*x+7,8*y+4);
	Bdisp_DrawLineVRAM(8*x+3,8*y+6,8*x+5,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+7,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+5,8*x+6,8*y+5);
	Bdisp_DrawLineVRAM(8*x+6,8*y+3,8*x+7,8*y+3);
	Bdisp_DrawLineVRAM(8*x+6,8*y+7,8*x+7,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+3,8*y+1,1);
	Bdisp_SetPoint_VRAM(8*x+7,8*y+6,1);
}


// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________



void Bdisp_Mine(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+4,8*x+1,8*y+5);
	Bdisp_DrawLineVRAM(8*x+2,8*y+1,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+4,8*x+3,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+1,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+6,8*y+1,8*x+6,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+3,8*x+7,8*y+3);
	Bdisp_DrawLineVRAM(8*x+5,8*y+7,8*x+7,8*y+5);
	Bdisp_SetPoint_VRAM(8*x+1,8*y+7,1);
	Bdisp_SetPoint_VRAM(8*x+5,8*y+5,1);
	Bdisp_SetPoint_VRAM(8*x+7,8*y+7,1);
}

void Bdisp_Reparateur(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x+2,8*y+1);
	Bdisp_DrawLineVRAM(8*x,8*y+4,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+3,8*x+3,8*y+3);
	Bdisp_DrawLineVRAM(8*x+1,8*y+7,8*x+3,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+2,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+1,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+4,8*y+3,8*x+6,8*y+1);
	Bdisp_DrawLineVRAM(8*x+4,8*y+4,8*x+4,8*y+6);
	Bdisp_DrawLineVRAM(8*x+4,8*y+7,8*x+6,8*y+5);
	Bdisp_DrawLineVRAM(8*x+6,8*y+2,8*x+6,8*y+4);
	Bdisp_SetPoint_VRAM(8*x+1,8*y+5,1);
	Bdisp_SetPoint_VRAM(8*x+3,8*y+5,1);
}

void Bdisp_BaseAv(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+4,8*x+3,8*y+1);
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+2,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+3,8*y+3);
	Bdisp_DrawLineVRAM(8*x+3,8*y+7,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+4,8*y+3);
	Bdisp_DrawLineVRAM(8*x+5,8*y+4,8*x+5,8*y+6);
	Bdisp_DrawLineVRAM(8*x+4,8*y+1,8*x+7,8*y+4);
	Bdisp_DrawLineVRAM(8*x+5,8*y+7,8*x+7,8*y+5);
}



// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________



void Bdisp_TourDef(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+2,8*y+5,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+1,8*x+3,8*y+4);
	Bdisp_DrawLineVRAM(8*x+4,8*y+1,8*x+4,8*y+4);
	Bdisp_DrawLineVRAM(8*x+5,8*y+2,8*x+6,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+5,8*x+5,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+2,8*y+2,1);
}

void Bdisp_Tourelle(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+3,8*x+3,8*y+4);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+4,8*y+4);
	Bdisp_DrawLineVRAM(8*x+5,8*y+5,8*x+5,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+5,8*y+1,1);
}

void Bdisp_TourRot(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+6,8*x+1,8*y+5);
	Bdisp_DrawLineVRAM(8*x+1,8*y+7,8*x+6,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+3,8*x+5,8*y+3);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+5,8*y+4);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+6,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+1,8*x+6,8*y+1);
	Bdisp_DrawLineVRAM(8*x+6,8*y+5,8*x+7,8*y+6);
}

void Bdisp_TourAv(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+2,8*y+2,8*x+2,8*y+3);
	Bdisp_DrawLineVRAM(8*x+3,8*y+1,8*x+4,8*y+1);
	Bdisp_DrawLineVRAM(8*x+3,8*y+4,8*x+3,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+4,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+5,8*y+2,8*x+5,8*y+3);
}


// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________



void Bdisp_Capitole_TL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+2,8*x+2,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+5,8*x+4,8*y+5);
	Bdisp_DrawLineVRAM(8*x+5,8*y+4,8*x+6,8*y+4);
	Bdisp_DrawLineVRAM(8*x+6,8*y+6,8*x+6,8*y+7);
	Bdisp_DrawLineVRAM(8*x+7,8*y+2,8*x+7,8*y+7);
}

void Bdisp_Capitole_TR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+4,8*x+2,8*y+4);
	Bdisp_DrawLineVRAM(8*x+1,8*y+6,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+5,8*x+4,8*y+5);
	Bdisp_DrawLineVRAM(8*x+5,8*y+1,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+6,8*y+2,8*x+6,8*y+7);
}

void Bdisp_Capitole_BL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+1,8*x,8*y+4);
	Bdisp_DrawLineVRAM(8*x+2,8*y+6,8*x+4,8*y+6);
	Bdisp_DrawLineVRAM(8*x+4,8*y+7,8*x+6,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+4,8*y+5);
	Bdisp_DrawLineVRAM(8*x+5,8*y,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+7,8*y,8*x+7,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+1,8*y,1);
	Bdisp_SetPoint_VRAM(8*x+1,8*y+5,1);
}

void Bdisp_Capitole_BR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y,8*x+2,8*y+1);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+3,8*y+5);
	Bdisp_DrawLineVRAM(8*x+1,8*y+7,8*x+3,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+6,8*x+5,8*y+6);
	Bdisp_DrawLineVRAM(8*x+7,8*y+1,8*x+7,8*y+4);
	Bdisp_SetPoint_VRAM(8*x+6,8*y,1);
	Bdisp_SetPoint_VRAM(8*x+6,8*y+5,1);
}

void Bdisp_Caserne_TL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+2,8*y+7,8*x+4,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+2,8*x+7,8*y+2);
	Bdisp_DrawLineVRAM(8*x+6,8*y+4,8*x+7,8*y+3);
	Bdisp_DrawLineVRAM(8*x+5,8*y+6,8*x+7,8*y+4);
	Bdisp_DrawLineVRAM(8*x+5,8*y+7,8*x+7,8*y+7);
}

void Bdisp_Caserne_TR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+4,8*x+3,8*y+4);
	Bdisp_DrawLineVRAM(8*x,8*y+7,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+6,8*x+3,8*y+5);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+6,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+7,8*x+7,8*y+2);
	Bdisp_DrawLineVRAM(8*x+7,8*y+3,8*x+7,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+4,8*y+3,1);
}

void Bdisp_Caserne_BL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+1,8*y+6);
	Bdisp_DrawLineVRAM(8*x+1,8*y,8*x+6,8*y);
	Bdisp_DrawLineVRAM(8*x+1,8*y+7,8*x+7,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+7,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y+6,8*x+5,8*y+5);
	Bdisp_DrawLineVRAM(8*x+6,8*y+6,8*x+6,8*y+4);
	Bdisp_DrawLineVRAM(8*x+7,8*y+6,8*x+7,8*y+4);
	Bdisp_SetPoint_VRAM(8*x+4,8*y+1,1);
	Bdisp_SetPoint_VRAM(8*x+6,8*y+1,1);
}

void Bdisp_Caserne_BR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x,8*y+6);
	Bdisp_DrawLineVRAM(8*x,8*y+2,8*x+1,8*y+2);
	Bdisp_DrawLineVRAM(8*x,8*y+7,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y,8*x+5,8*y);
	Bdisp_DrawLineVRAM(8*x+4,8*y+1,8*x+4,8*y+6);
	Bdisp_DrawLineVRAM(8*x+5,8*y+5,8*x+7,8*y);
	Bdisp_SetPoint_VRAM(8*x+1,8*y+1,1);
}

void Bdisp_Usine_TL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+6,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x+3,8*y+2);
	Bdisp_DrawLineVRAM(8*x+1,8*y+5,8*x+7,8*y+5);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+7,8*y+2);
}

void Bdisp_Usine_TR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+2,8*x+1,8*y+2);
	Bdisp_DrawLineVRAM(8*x,8*y+4,8*x+2,8*y+2);
	Bdisp_DrawLineVRAM(8*x,8*y+6,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+1,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+5,8*y+1,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+6,8*y+6,8*x+7,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+3,8*y+3,1);
}

void Bdisp_Usine_BL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y,8*x,8*y+6);
	Bdisp_DrawLineVRAM(8*x,8*y+7,8*x+7,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+3,8*x+3,8*y+6);
	Bdisp_DrawLineVRAM(8*x+4,8*y+3,8*x+7,8*y+3);
}

void Bdisp_Usine_BR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x+1,8*y+3);
	Bdisp_DrawLineVRAM(8*x,8*y+7,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+4,8*x+1,8*y+6);
	Bdisp_DrawLineVRAM(8*x+2,8*y,8*x+3,8*y+1);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+4,8*y+6);
	Bdisp_DrawLineVRAM(8*x+5,8*y+1,8*x+6,8*y);
	Bdisp_DrawLineVRAM(8*x+5,8*y+6,8*x+7,8*y+4);
	Bdisp_DrawLineVRAM(8*x+7,8*y,8*x+7,8*y+3);
}

void Bdisp_Aeroport_TL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+1,8*x,8*y+5);
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+1,8*y+2,8*x+2,8*y+3);
	Bdisp_DrawLineVRAM(8*x+1,8*y+6,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+4,8*x+3,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y+4,8*x+7,8*y+4);
	Bdisp_DrawLineVRAM(8*x+4,8*y+5,8*x+6,8*y+5);
	Bdisp_DrawLineVRAM(8*x+6,8*y+1,8*x+7,8*y+2);
	Bdisp_SetPoint_VRAM(8*x+7,8*y+6,1);
}

void Bdisp_Aeroport_TR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x,8*y+4);
	Bdisp_DrawLineVRAM(8*x+1,8*y+4,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+3,8*x+3,8*y+5);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+6,8*y+2);
	Bdisp_DrawLineVRAM(8*x+4,8*y+5,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+5,8*y+5,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+6,8*y+5,8*x+6,8*y+7);
	Bdisp_DrawLineVRAM(8*x+7,8*y+3,8*x+7,8*y+5);
	Bdisp_SetPoint_VRAM(8*x,8*y+7,1);
}

void Bdisp_Aeroport_BL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+3,8*y,8*x+7,8*y+4);
	Bdisp_DrawLineVRAM(8*x+6,8*y,8*x+7,8*y+1);
}

void Bdisp_Aeroport_BR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y,8*x+7,8*y+6);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+3,8*y+5);
	Bdisp_DrawLineVRAM(8*x+3,8*y+7,8*x+7,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y,8*x+4,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y,8*x+5,8*y+3);
	Bdisp_DrawLineVRAM(8*x+6,8*y,8*x+6,8*y+4);
}


// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

void Bdisp_BaseMiss_TL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+4,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+5,8*x+3,8*y+7);
	Bdisp_DrawLineVRAM(8*x+5,8*y+1,8*x+6,8*y+2);
	Bdisp_DrawLineVRAM(8*x+6,8*y+4,8*x+6,8*y+5);
	Bdisp_DrawLineVRAM(8*x+7,8*y+3,8*x+7,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+5,8*y+5,1);
}

void Bdisp_BaseMiss_TR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+2,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+1,8*y+5);
	Bdisp_DrawLineVRAM(8*x+4,8*y+5,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+5,8*y+4,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+6,8*y+4,8*x+6,8*y+7);
	Bdisp_DrawLineVRAM(8*x+7,8*y+5,8*x+7,8*y+7);
}

void Bdisp_BaseMiss_BL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y,8*x+7,8*y);
	Bdisp_DrawLineVRAM(8*x,8*y+2,8*x+3,8*y+2);
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x+3,8*y+3);
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+2,8*y+1);
	Bdisp_DrawLineVRAM(8*x+5,8*y+4,8*x+5,8*y+6);
	Bdisp_DrawLineVRAM(8*x+6,8*y+1,8*x+6,8*y+3);
	Bdisp_DrawLineVRAM(8*x+6,8*y+5,8*x+6,8*y+6);
	Bdisp_DrawLineVRAM(8*x+6,8*y+7,8*x+7,8*y+7);
	Bdisp_DrawLineVRAM(8*x+7,8*y+1,8*x+7,8*y+4);
}

void Bdisp_BaseMiss_BR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y,8*x+7,8*y);
	Bdisp_DrawLineVRAM(8*x,8*y+1,8*x,8*y+4);
	Bdisp_DrawLineVRAM(8*x,8*y+7,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+1,8*y+3);
	Bdisp_DrawLineVRAM(8*x+1,8*y+5,8*x+1,8*y+6);
	Bdisp_DrawLineVRAM(8*x+2,8*y+4,8*x+2,8*y+6);
	Bdisp_DrawLineVRAM(8*x+4,8*y+2,8*x+7,8*y+2);
	Bdisp_DrawLineVRAM(8*x+4,8*y+3,8*x+7,8*y+3);
	Bdisp_DrawLineVRAM(8*x+5,8*y+1,8*x+6,8*y+1);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

void Bdisp_BunkeRap_TL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+2,8*y+7,8*x+7,8*y+2);
	Bdisp_DrawLineVRAM(8*x+7,8*y+3,8*x+7,8*y+7);

}

void Bdisp_BunkeRap_TR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+2,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x,8*y+7);

}

void Bdisp_BunkeRap_BL(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+1,8*x+6,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+2,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+4,8*y+4,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+7,8*y,8*x+7,8*y+7);
	Bdisp_SetPoint_VRAM(8*x+1,8*y,1);
}

void Bdisp_BunkeRap_BR(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+7,8*x+7,8*y+1);
	Bdisp_DrawLineVRAM(8*x+2,8*y+1,8*x+3,8*y+4);
	Bdisp_DrawLineVRAM(8*x+2,8*y+1,8*x+5,8*y+2);
	Bdisp_SetPoint_VRAM(8*x+6,8*y,1);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

void Bdisp_TourSup_TT(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+1,8*y+2,8*x+1,8*y+5);
	Bdisp_DrawLineVRAM(8*x+2,8*y+1,8*x+5,8*y+1);
	Bdisp_DrawLineVRAM(8*x+2,8*y+6,8*x+5,8*y+6);
	Bdisp_DrawLineVRAM(8*x+2,8*y+7,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+6,8*y+2,8*x+6,8*y+5);
}

void Bdisp_TourSup_BB(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+3,8*x+1,8*y+2);
	Bdisp_DrawLineVRAM(8*x,8*y+5,8*x+1,8*y+6);
	Bdisp_DrawLineVRAM(8*x+1,8*y+1,8*x+2,8*y);
	Bdisp_DrawLineVRAM(8*x+3,8*y,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+3,8*y+7,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+4,8*y,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+5,8*y,8*x+6,8*y+1);
	Bdisp_DrawLineVRAM(8*x+6,8*y+2,8*x+7,8*y+3);
	Bdisp_DrawLineVRAM(8*x+6,8*y+6,8*x+7,8*y+5);
	Bdisp_SetPoint_VRAM(8*x,8*y+4,1);
	Bdisp_SetPoint_VRAM(8*x+7,8*y+4,1);
}

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

void Bdisp_WarFog(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y,8*x+7,8*y+7);
	Bdisp_DrawLineVRAM(8*x,8*y+2,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x,8*y+4,8*x+3,8*y+7);
	Bdisp_DrawLineVRAM(8*x,8*y+6,8*x+1,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y,8*x+7,8*y+5);
	Bdisp_DrawLineVRAM(8*x+4,8*y,8*x+7,8*y+3);
	Bdisp_DrawLineVRAM(8*x+6,8*y,8*x+7,8*y+1);
}


void Bdisp_Tree(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x+1,8*y+6,8*x+2,8*y+3);
	Bdisp_DrawLineVRAM(8*x+2,8*y+6,8*x+5,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y+1,8*x+4,8*y+1);
	Bdisp_DrawLineVRAM(8*x+3,8*y+2,8*x+4,8*y+2);
	Bdisp_DrawLineVRAM(8*x+3,8*y+7,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+5,8*y+3,8*x+6,8*y+6);
}


void Bdisp_Mount(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y,8*x,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y,8*x+1,8*y+2);
	Bdisp_DrawLineVRAM(8*x+1,8*y+7,8*x+4,8*y+7);
	Bdisp_DrawLineVRAM(8*x+2,8*y+3,8*x+2,8*y+6);
	Bdisp_DrawLineVRAM(8*x+3,8*y,8*x+3,8*y+1);
	Bdisp_DrawLineVRAM(8*x+3,8*y+5,8*x+3,8*y+6);
	Bdisp_DrawLineVRAM(8*x+4,8*y,8*x+4,8*y+2);
	Bdisp_DrawLineVRAM(8*x+5,8*y,8*x+5,8*y+7);
	Bdisp_DrawLineVRAM(8*x+6,8*y,8*x+6,8*y+7);
	Bdisp_DrawLineVRAM(8*x+7,8*y,8*x+7,8*y+7);
}

void Bdisp_Ressource(int x, int y)
{
	Bdisp_DrawLineVRAM(8*x,8*y+7,8*x+2,8*y+7);
	Bdisp_DrawLineVRAM(8*x+1,8*y+6,8*x+3,8*y+6);
	Bdisp_DrawLineVRAM(8*x+5,8*y+7,8*x+7,8*y+5);
	Bdisp_SetPoint_VRAM(8*x+5,8*y+5,1);
	Bdisp_SetPoint_VRAM(8*x+7,8*y+7,1);
}