extern "C"
{
#include "fxlib.h"
#include "stddef.h"
#include <math.h>
}

#include "OtherFunc.hpp"
#include "Graphics.hpp"
#include "Classes.hpp"
#include "Timer.hpp"
#include "Game.hpp"


// Code
bool Brainstorm;

void Set_Brainstorm(bool ay)
{
	Brainstorm = ay;
}

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________
// Selection d'unites et action sur ces unites

Unite* Selected[10];
bool IsAllie;
Unite* Save[10][10];

int Sel_Num()
{
	if(Selected[0] == 0) return 0;
	return Selected[0]->Get_Type();
}

void Unselect()
{
	for(int i = 0; i<10; i++) Selected[i] = 0;
}

void Select(Unite* Select, bool IsAllieB)
{
	IsAllie = IsAllieB;
	if(!IsAllie) Unselect();
	for(int i = 0; i<10; i++) {
		if(Selected[i] == 0) {
			Selected[i] = Select;
			break;
		}
		if(Selected[i] == Select) break;
	}
}

void Bdisp_PutSelected()
{
	char ch[10];
	int i;
	for(i = 0; i<10; i++) if(Selected[i] != 0) if(Selected[i]->Get_Type() == 0) Selected[i] = 0;
	if(Selected[0] != 0) {
		int2str(ch, Selected[0]->Get_Type());
	}
	else {
		ch[0] = 0;
	}
	i = 0;
	while(i < 10) {
		int j;
		for(i = 0; i < 10; i++) if(Selected[i] == 0) break;
		for(j = i; j<10; j++) {
			if(Selected[j] != 0) {
				i++;
				Selected[i] = Selected[j];
				Selected[j] = 0;
			}
		}
		if(j == 10) break;
	}
	for(int j = 0; j < i; j++) {
		PrintMini(115,50,(unsigned char*) ch, MINI_OVER);
		if(Selected[j] != 0) if(Selected[j]->Get_Type() != 0) Bdisp_HealthBar(115, 46-4*j,( Selected[j]->Get_HealthPoints() * 100 / Selected[j]->Get_HealthPointsMax()));
	}
}

void Bdisp_Info()
{
	char c[10], ch[12];
	int i, j;
	if(Selected[0] != 0) {
		PopUpWin(6);
		int2str(ch, Selected[0]->Get_Type());
		PrintMini(11,5,(unsigned char*) "Type", MINI_OVER);
		PrintMini(30,5,(unsigned char*) ch,MINI_OVER);

		PrintMini(11,13,(unsigned char*) "Life", MINI_OVER);
		int2str(ch, Selected[0]->Get_HealthPoints());
		for(i = 0; ch[i] != 0; i++);
		ch[i] = '/';
		i++;
		int2str(c, Selected[0]->Get_HealthPointsMax());
		for(j = 0; c[j] != 0; j++) ch[i+j] = c[j];
		ch[i+j] = 0;
		PrintMini(27,13,(unsigned char*) ch,MINI_OVER);

		PrintMini(11,21,(unsigned char*) "Attack", MINI_OVER);
		int2str(ch, Selected[0]->Get_Attack());
		for(i = 0; ch[i] != 0; i++);
		ch[i] = '-';
		i++;
		int2str(c, Selected[0]->Get_AA_Attack());
		for(j = 0; c[j] != 0; j++) ch[i+j] = c[j];
		ch[i+j] = 0;
		PrintMini(38,21,(unsigned char*) ch,MINI_OVER);

		PrintMini(11,29,(unsigned char*) "Range", MINI_OVER);
		int2str(ch, Selected[0]->Get_Range());
		for(i = 0; ch[i] != 0; i++);
		ch[i] = '/';
		i++;
		int2str(c, Selected[0]->Get_Visibility());
		for(j = 0; c[j] != 0; j++) ch[i+j] = c[j];
		ch[i+j] = 0;
		PrintMini(35,29,(unsigned char*) ch,MINI_OVER);

		PrintMini(11,37,(unsigned char*) "Cargo", MINI_OVER);
		int2str(ch, Selected[0]->Get_CargoNumber());
		for(i = 0; ch[i] != 0; i++);
		ch[i] = '/';
		i++;
		int2str(c, Selected[0]->Get_CargoMax());
		for(j = 0; c[j] != 0; j++) ch[i+j] = c[j];
		ch[i+j] = 0;
		PrintMini(35,37,(unsigned char*) ch,MINI_OVER);

		Bdisp_PutDisp_DD();
	}
	else {
		PopUpWin(1);
		locate(5,4);
		Print((unsigned char*) "No unit !");
		Bdisp_PutDisp_DD();
	}
}

void Sel_Delete()
{
	if(IsAllie) {
		for(int i = 0; i < 10; i++) {
			if(Selected[i] != 0) {
				if (Selected[i]->Get_Type() != 20) {
					Revenu(Get_Prize(Selected[i]->Get_Type())/2);
					Selected[i]->Delete();
				}
			}
		}
		Unselect();
	}
}

void Sel_Save(int n)
{
	if(IsAllie) for(int i = 0; i<10; i++) Save[i][n] = Selected[i];
}

void Sel_Restore(int n)
{
	for(int i = 0; i<10; i++) {
		IsAllie = true;
		if(Selected[i] != Save[i][n]) Selected[i] = Save[i][n];
		else if(Selected[i] != 0) CenterCam(Selected[i]->Get_PositionX(), Selected[i]->Get_PositionY());
	}
}

void Sel_Move(int X, int Y)
{
	if(IsAllie) {
		for(int i = 0; i<10; i++) {
			if(Selected[i] != 0) {
				Selected[i]->GoTo(X, Y);
			}
		}
	}
}

void Sel_Attack(Unite* unit)
{
	if(IsAllie) {
		for(int i = 0; i<10; i++) {
			if(Selected[i] != 0) {
				Selected[i]->Attack(unit);
			}
		}
	}
}

void SwitchUp()
{
	if(Selected[0] != 0) {
		Unite *Unit2;
		int i;

		Unit2 = Selected[0];
		i = 1;
		while ((i < 10) && (Selected[i] != 0)) {
			Selected[i - 1] = Selected[i];
			i++;
		}
		Selected[i-1] = Unit2;
	}
}

void Sel_Cargo(Unite* unit)
{
	if(IsAllie) {
		for(int i = 0; i<10; i++) {
			if(Selected[i] != 0) {
				unit->Cargo_In(Selected[i]);
			}
		}
	}
}

void Sel_CargoOut()
{
	if(Selected[0] != 0 && IsAllie) {
		if((Selected[0]->Get_PositionX() == get_PositionX_Mouse()+1) || (Selected[0]->Get_PositionX() == get_PositionX_Mouse()-1) || (Selected[0]->Get_PositionY() == get_PositionY_Mouse()+1) || (Selected[0]->Get_PositionY() == get_PositionY_Mouse()-1)) {
			for(int j = 0; j<Selected[0]->Get_CargoMax(); j++) {
				Selected[0]->Cargo_Out(j, get_PositionX_Mouse(), get_PositionY_Mouse());
			}
		}
	}
}

void Sel_CapaSpe()
{
	if(Selected[0] != 0 && IsAllie) {
		Selected[0]->SpecialCapacity();
	}
}
void Sel_Build()
{
	int x, y, n;
	char ch[10];
	Unite *v;
	if(Selected[0] != 0 && IsAllie) {
		if(Selected[0]->Get_IsStop()) {
			switch(Selected[0]->Get_Type())
			{
				case 20 : 
					x = get_PositionX_Mouse();
					y = get_PositionY_Mouse();
					if(!Can_Build(20, x, y) && !Can_Build(12, x, y)) break;
					if(Test_XY(x,y) != 0) if(Test_XY(x,y) != -4) break;
					n = 1;
					while(IsKeyDown(KEY_CTRL_EXE));
					while(IsKeyUp(KEY_CTRL_EXE)) {
						PopUpWin(3);
						locate(5,3); Print((unsigned char*) "Build :");
						locate(6,5); Print((unsigned char*) "$");
						locate(4,4);
						if(Test_XY(x,y) == -4) {
							Print((unsigned char*) "  Mine  ");
							int2str(ch, Get_Prize(10));
							locate(7,5);
							Print((unsigned char*) ch);
						}
						else{
							switch(n)
							{
								case 1 : Print((unsigned char*) "< Tr. camp >"); int2str(ch, Get_Prize(25)); locate(7,5); Print((unsigned char*) ch); break;
								case 2 : Print((unsigned char*) "< Tank factory >"); int2str(ch, Get_Prize(30)); locate(7,5); Print((unsigned char*) ch); break;
								case 3 : Print((unsigned char*) "< Airport >"); int2str(ch, Get_Prize(35)); locate(7,5); Print((unsigned char*) ch); break;
								case 4 : Print((unsigned char*) "< Repairer >"); int2str(ch, Get_Prize(11)); locate(7,5); Print((unsigned char*) ch); break;
								case 5 : Print((unsigned char*) "< Defense >"); int2str(ch, Get_Prize(13)); locate(7,5); Print((unsigned char*) ch); break;
								case 6 : Print((unsigned char*) "< Turret >"); int2str(ch, Get_Prize(14)); locate(7,5); Print((unsigned char*) ch); break;
								case 7 : Print((unsigned char*) "< Rotative >"); int2str(ch, Get_Prize(15)); locate(7,5); Print((unsigned char*) ch); break;
								case 8 : Print((unsigned char*) "< Advanced >"); int2str(ch, Get_Prize(16)); locate(7,5); Print((unsigned char*) ch); break;
							}
						}
						Bdisp_PutDisp_DD();
						if(IsKeyDown(KEY_CTRL_LEFT)) {
							n--;
							if(n == 0) n = 8;
							Sleep(200);
						}
						if(IsKeyDown(KEY_CTRL_RIGHT)) {
							n++;
							if(n == 9) n = 1;
							Sleep(200);
						}
						if(IsKeyDown(KEY_CTRL_EXIT)) {
							n = 0;
							break;
						}
					}
					if(n == 0) break;
					switch(n)
					{
						case 1 : n = 25; break;
						case 2 : n = 30; break;
						case 3 : n = 35; break;
						case 4 : n = 11; break;
						case 5 : n = 13; break;
						case 6 : n = 14; break;
						case 7 : n = 15; break;
						case 8 : n = 16; break;
					}
					if(Test_XY(x,y) == -4) n = 10;
					if(!Depense(Get_Prize(n))) break;
					v = NewUnit_Alliee();
					if(v == 0) break;
					v->Create(n, x, y);
					if(!Brainstorm) {
						v->Stop(Get_BuildTime(n));
						Selected[0]->Stop(Get_BuildTime(n));
					}
					break;
				case 25 : 
					x = get_PositionX_Mouse();
					y = get_PositionY_Mouse();
					if((Test_XY(x, y) != 0) || !Can_Build(25, x, y)) break;
					n = 1;
					while(IsKeyDown(KEY_CTRL_EXE));
					while(IsKeyUp(KEY_CTRL_EXE)) {
						PopUpWin(3);
						locate(5,3); Print((unsigned char*) "Build :");
						locate(6,5); Print((unsigned char*) "$");
						locate(4,4);
						switch(n)
						{
							case 1 : Print((unsigned char*) "< Soldat >"); int2str(ch, Get_Prize(1)); locate(7,5); Print((unsigned char*) ch); break;
							case 2 : Print((unsigned char*) "< Trooper >"); int2str(ch, Get_Prize(2)); locate(7,5); Print((unsigned char*) ch); break;
							case 3 : Print((unsigned char*) "< Agent >"); int2str(ch, Get_Prize(3)); locate(7,5); Print((unsigned char*) ch); break;
						}
						Bdisp_PutDisp_DD();
						if(IsKeyDown(KEY_CTRL_LEFT)) {
							n--;
							if(n == 0) n = 3;
							Sleep(150);
						}
						if(IsKeyDown(KEY_CTRL_RIGHT)) {
							n++;
							if(n == 4) n = 1;
							Sleep(150);
						}
						if(IsKeyDown(KEY_CTRL_EXIT)) {
							n = 0;
							break;
						}
					}
					if(n == 0) break;
					switch(n)
					{
						case 1 : n = 1; break;
						case 2 : n = 2; break;
						case 3 : n = 3; break;
					}
					v = NewUnit_Alliee();
					if(v == 0) break;
					v->Create(n, x, y);
					if(!Brainstorm) {
						v->Stop(Get_BuildTime(n));
						Selected[0]->Stop(Get_BuildTime(n));
					}
					break;
				case 30 : 
					x = get_PositionX_Mouse();
					y = get_PositionY_Mouse();
					if((Test_XY(x, y) != 0) || !Can_Build(30, x, y)) break;
					n = 1;
					while(IsKeyDown(KEY_CTRL_EXE));
					while(IsKeyUp(KEY_CTRL_EXE)) {
						PopUpWin(3);
						locate(5,3); Print((unsigned char*) "Build :");
						locate(6,5); Print((unsigned char*) "$");
						locate(4,4);
						switch(n)
						{
							case 1 : Print((unsigned char*) "< Transporter >"); int2str(ch, Get_Prize(4)); locate(7,5); Print((unsigned char*) ch); break;
							case 2 : Print((unsigned char*) "< Tank >"); int2str(ch, Get_Prize(5)); locate(7,5); Print((unsigned char*) ch); break;
							case 3 : Print((unsigned char*) "< Rotative T. >"); int2str(ch, Get_Prize(6)); locate(7,5); Print((unsigned char*) ch); break;
						}
						Bdisp_PutDisp_DD();
						if(IsKeyDown(KEY_CTRL_LEFT)) {
							n--;
							if(n == 0) n = 3;
							Sleep(150);
						}
						if(IsKeyDown(KEY_CTRL_RIGHT)) {
							n++;
							if(n == 4) n = 1;
							Sleep(150);
						}
						if(IsKeyDown(KEY_CTRL_EXIT)) {
							n = 0;
							break;
						}
					}
					if(n == 0) break;
					switch(n)
					{
						case 1 : n = 4; break;
						case 2 : n = 5; break;
						case 3 : n = 6; break;
					}
					v = NewUnit_Alliee();
					if(v == 0) break;
					v->Create(n, x, y);
					if(!Brainstorm) {
						v->Stop(Get_BuildTime(n));
						Selected[0]->Stop(Get_BuildTime(n));
					}
					break;
				case 35 : 
					x = get_PositionX_Mouse();
					y = get_PositionY_Mouse();
					if((Test_XY(x, y) != 0) || !Can_Build(35, x, y)) break;
					n = 1;
					while(IsKeyDown(KEY_CTRL_EXE));
					while(IsKeyUp(KEY_CTRL_EXE)) {
						PopUpWin(3);
						locate(5,3); Print((unsigned char*) "Build :");
						locate(6,5); Print((unsigned char*) "$");
						locate(4,4);
						switch(n)
						{
							case 1 : Print((unsigned char*) "< Helicopter >"); int2str(ch, Get_Prize(7)); locate(7,5); Print((unsigned char*) ch); break;
							case 2 : Print((unsigned char*) "< Hunter >"); int2str(ch, Get_Prize(8)); locate(7,5); Print((unsigned char*) ch); break;
							case 3 : Print((unsigned char*) "< Bomber >"); int2str(ch, Get_Prize(9)); locate(7,5); Print((unsigned char*) ch); break;
						}
						Bdisp_PutDisp_DD();
						if(IsKeyDown(KEY_CTRL_LEFT)) {
							n--;
							if(n == 0) n = 3;
							Sleep(150);
						}
						if(IsKeyDown(KEY_CTRL_RIGHT)) {
							n++;
							if(n == 4) n = 1;
							Sleep(150);
						}
						if(IsKeyDown(KEY_CTRL_EXIT)) {
							n = 0;
							break;
						}
					}
					if(n == 0) break;
					switch(n)
					{
						case 1 : n = 7; break;
						case 2 : n = 8; break;
						case 3 : n = 9; break;
					}
					v = NewUnit_Alliee();
					if(v == 0) break;
					v->Create(n, x, y);
					if(!Brainstorm) {
						v->Stop(Get_BuildTime(n));
						Selected[0]->Stop(Get_BuildTime(n));
					}
					break;
				default : break;
			}
		}
	}
}

void Sel_IsCross()
{
	if(Selected[0] != 0 && IsAllie) {
		if(Selected[0]->Get_IsStop()) {
			Cross_On();
		}
		else {
			Cross_Off();
		}
	}
	else {
		Cross_Off();
	}
}

bool Sel_IsStop()
{
	if(Selected[0] != 0 && IsAllie) {
		return Selected[0]->Get_IsStop();
	}
	return false;
}


// _________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________

bool Test_Range(int aX, int aY, int range, int bX, int bY)
{
	if((fabs(aX-bX)+fabs(aY-bY)) <= range) return true;
	return false;
}

bool Test_Range(int aX, int aY, int range, int bX, int bY, bool rangeMax)
{
	if((fabs(aX-bX)+fabs(aY-bY)) <= range) return true;
	return false;
}

void int2str(char *c, int n)
{
	if(n == 0) {
		c[0] = '0';
		c[1] = 0;
	}
	else {
		int i;
		int n2;
		n2 = n;
		for(i = 0; n2 != 0; i++) n2 = n2/10;
		i--;
		c[i+1] = 0;
		n2 = n;
		if(n == 0) i = 0; 
		for(i; i>=0; i--){
			switch((n2)%10) {
				case 0 : c[i] = '0'; break;
				case 1 : c[i] = '1'; break;
				case 2 : c[i] = '2'; break;
				case 3 : c[i] = '3'; break;
				case 4 : c[i] = '4'; break;
				case 5 : c[i] = '5'; break;
				case 6 : c[i] = '6'; break;
				case 7 : c[i] = '7'; break;
				case 8 : c[i] = '8'; break;
				case 9 : c[i] = '9'; break;
				default : c[i] = '0'; break;
			}
			n2 = n2/10;
			if(n2 == 0) break;
		}
	}
}

//__________________________________________________________________________________________________________________________________________________
// Donnees

int Get_Prize(char type)
{
	int a;
	switch(type)
	{
		case 1 : a = 50; break;
		case 2 : a = 150; break;
		case 3 : a = 350; break;
		case 4 : a = 1500; break;
		case 5 : a = 1200; break;
		case 6 : a = 1500; break;
		case 7 : a = 1500; break;
		case 8 : a = 1500; break;
		case 9 : a = 2500; break;
		case 10 : a = 500; break;
		case 11 : a = 2500; break;
		case 13 : a = 500; break;
		case 14 : a = 500; break;
		case 15 : a = 2000; break;
		case 16 : a = 5000; break;
		case 20 : a = 10000; break;
		case 25 : a = 1000; break;
		case 30 : a = 3000; break;
		case 35 : a = 7500; break;
		default : a = 0; break;
	}
	return a;
}

float Get_BuildTime(char type)
{
	float a;
	switch(type)
	{
		case 1 : a = 5; break;
		case 2 : a = 10; break;
		case 3 : a = 30; break;
		case 4 : a = 15; break;
		case 5 : a = 20; break;
		case 6 : a = 30; break;
		case 7 : a = 15; break;
		case 8 : a = 15; break;
		case 9 : a = 30; break;
		case 10 : a = 15; break;
		case 11 : a = 15; break;
		case 13 : a = 10; break;
		case 14 : a = 10; break;
		case 15 : a = 20; break;
		case 16 : a = 45; break;
		case 25 : a = 10; break;
		case 30 : a = 15; break;
		case 35 : a = 15; break;
		default : a = 0; break;
	}
	return a;
}

// ___________________________________________________________________________________________________________________________________________________________________________________________________________________________________________________
